// for SmallerC IO registor definition.

#define ORIG 0
#define CLR 1
#define SET 2
#define INV 3

#define USE_TIMER 
//#define USE_IC    
#define USE_OC    
//#define USE_I2C   
//#define USE_SPI   
//#define USE_UART  
//#define USE_PM    
//#define USE_ADC   
#define USE_REMAP 
//#define USE_INT   
#define USE_DMA   
#define USE_PORT  

#ifdef USE_TIMER
#define RTCCON ((unsigned*)(0xBF800200))
#define RTCALRM ((unsigned*)(0xBF800210))
#define RTCTIME ((unsigned*)(0xBF800220))
#define RTCDATE ((unsigned*)(0xBF800230))
#define ALRMTIME ((unsigned*)(0xBF800240))
#define ALRMDATE ((unsigned*)(0xBF800250))
#define T1CON ((unsigned*)(0xBF800600))
#define TMR1 ((unsigned*)(0xBF800610))
#define PR1 ((unsigned*)(0xBF800620))
#define T2CON ((unsigned*)(0xBF800800))
#define TMR2 ((unsigned*)(0xBF800810))
#define PR2 ((unsigned*)(0xBF800820))
#define T3CON ((unsigned*)(0xBF800A00))
#define TMR3 ((unsigned*)(0xBF800A10))
#define PR3 ((unsigned*)(0xBF800A20))
#define T4CON ((unsigned*)(0xBF800C00))
#define TMR4 ((unsigned*)(0xBF800C10))
#define PR4 ((unsigned*)(0xBF800C20))
#define T5CON ((unsigned*)(0xBF800E00))
#define TMR5 ((unsigned*)(0xBF800E10))
#define PR5 ((unsigned*)(0xBF800E20))
#endif

#ifdef USE_IC
#define IC1CON ((unsigned*)(0xBF802000))
#define IC1BUF ((unsigned*)(0xBF802010))
#define IC2CON ((unsigned*)(0xBF802200))
#define IC2BUF ((unsigned*)(0xBF802210))
#define IC3CON ((unsigned*)(0xBF802400))
#define IC3BUF ((unsigned*)(0xBF802410))
#define IC4CON ((unsigned*)(0xBF802600))
#define IC4BUF ((unsigned*)(0xBF802610))
#define IC5CON ((unsigned*)(0xBF802800))
#define IC5BUF ((unsigned*)(0xBF802810))
#endif

#ifdef USE_OC
#define OC1CON ((unsigned*)(0xBF803000))
#define OC1R ((unsigned*)(0xBF803010))
#define OC1RS ((unsigned*)(0xBF803020))
#define OC2CON ((unsigned*)(0xBF803200))
#define OC2R ((unsigned*)(0xBF803210))
#define OC2RS ((unsigned*)(0xBF803220))
#define OC3CON ((unsigned*)(0xBF803400))
#define OC3R ((unsigned*)(0xBF803410))
#define OC3RS ((unsigned*)(0xBF803420))
#define OC4CON ((unsigned*)(0xBF803600))
#define OC4R ((unsigned*)(0xBF803610))
#define OC4RS ((unsigned*)(0xBF803620))
#define OC5CON ((unsigned*)(0xBF803800))
#define OC5R ((unsigned*)(0xBF803810))
#define OC5RS ((unsigned*)(0xBF803820))
#endif

#ifdef USE_I2C
#define I2C1ACON ((unsigned*)(0xBF805000))
#define I2C1CON ((unsigned*)(0xBF805000))
#define I2C1ASTAT ((unsigned*)(0xBF805010))
#define I2C1STAT ((unsigned*)(0xBF805010))
#define I2C1AADD ((unsigned*)(0xBF805020))
#define I2C1ADD ((unsigned*)(0xBF805020))
#define I2C1AMSK ((unsigned*)(0xBF805030))
#define I2C1MSK ((unsigned*)(0xBF805030))
#define I2C1ABRG ((unsigned*)(0xBF805040))
#define I2C1BRG ((unsigned*)(0xBF805040))
#define I2C1ATRN ((unsigned*)(0xBF805050))
#define I2C1TRN ((unsigned*)(0xBF805050))
#define I2C1ARCV ((unsigned*)(0xBF805060))
#define I2C1RCV ((unsigned*)(0xBF805060))
#define I2C2ACON ((unsigned*)(0xBF805100))
#define I2C2CON ((unsigned*)(0xBF805100))
#define I2C2ASTAT ((unsigned*)(0xBF805110))
#define I2C2STAT ((unsigned*)(0xBF805110))
#define I2C2AADD ((unsigned*)(0xBF805120))
#define I2C2ADD ((unsigned*)(0xBF805120))
#define I2C2AMSK ((unsigned*)(0xBF805130))
#define I2C2MSK ((unsigned*)(0xBF805130))
#define I2C2ABRG ((unsigned*)(0xBF805140))
#define I2C2BRG ((unsigned*)(0xBF805140))
#define I2C2ATRN ((unsigned*)(0xBF805150))
#define I2C2TRN ((unsigned*)(0xBF805150))
#define I2C2ARCV ((unsigned*)(0xBF805160))
#define I2C2RCV ((unsigned*)(0xBF805160))
#endif

#ifdef USE_SPI
#define SPI1CON ((unsigned*)(0xBF805800))
#define SPI1STAT ((unsigned*)(0xBF805810))
#define SPI1BUF ((unsigned*)(0xBF805820))
#define SPI1BRG ((unsigned*)(0xBF805830))
#define SPI1CON2 ((unsigned*)(0xBF805840))
#define SPI2CON ((unsigned*)(0xBF805A00))
#define SPI2STAT ((unsigned*)(0xBF805A10))
#define SPI2BUF ((unsigned*)(0xBF805A20))
#define SPI2BRG ((unsigned*)(0xBF805A30))
#define SPI2CON2 ((unsigned*)(0xBF805A40))
#endif

#ifdef USE_UART
#define U1AMODE ((unsigned*)(0xBF806000))
#define U1MODE ((unsigned*)(0xBF806000))
#define U1ASTA ((unsigned*)(0xBF806010))
#define U1STA ((unsigned*)(0xBF806010))
#define U1ATXREG ((unsigned*)(0xBF806020))
#define U1TXREG ((unsigned*)(0xBF806020))
#define U1ARXREG ((unsigned*)(0xBF806030))
#define U1RXREG ((unsigned*)(0xBF806030))
#define U1ABRG ((unsigned*)(0xBF806040))
#define U1BRG ((unsigned*)(0xBF806040))
#define U2MODE ((unsigned*)(0xBF806200))
#define U3AMODE ((unsigned*)(0xBF806200))
#define U2STA ((unsigned*)(0xBF806210))
#define U3ASTA ((unsigned*)(0xBF806210))
#define U2TXREG ((unsigned*)(0xBF806220))
#define U3ATXREG ((unsigned*)(0xBF806220))
#define U2RXREG ((unsigned*)(0xBF806230))
#define U3ARXREG ((unsigned*)(0xBF806230))
#define U2BRG ((unsigned*)(0xBF806240))
#define U3ABRG ((unsigned*)(0xBF806240))
#endif

#ifdef USE_PM
#define PMCON ((unsigned*)(0xBF807000))
#define PMMODE ((unsigned*)(0xBF807010))
#define PMADDR ((unsigned*)(0xBF807020))
#define PMDOUT ((unsigned*)(0xBF807030))
#define PMDIN ((unsigned*)(0xBF807040))
#define PMAEN ((unsigned*)(0xBF807050))
#define PMSTAT ((unsigned*)(0xBF807060))
#endif

#ifdef USE_ADC
#define AD1CON1 ((unsigned*)(0xBF809000))
#define AD1CON2 ((unsigned*)(0xBF809010))
#define AD1CON3 ((unsigned*)(0xBF809020))
#define AD1CHS ((unsigned*)(0xBF809040))
#define AD1CSSL ((unsigned*)(0xBF809050))
#define ADC1BUF0 ((unsigned*)(0xBF809070))
#define ADC1BUF1 ((unsigned*)(0xBF809080))
#define ADC1BUF2 ((unsigned*)(0xBF809090))
#define ADC1BUF3 ((unsigned*)(0xBF8090A0))
#define ADC1BUF4 ((unsigned*)(0xBF8090B0))
#define ADC1BUF5 ((unsigned*)(0xBF8090C0))
#define ADC1BUF6 ((unsigned*)(0xBF8090D0))
#define ADC1BUF7 ((unsigned*)(0xBF8090E0))
#define ADC1BUF8 ((unsigned*)(0xBF8090F0))
#define ADC1BUF9 ((unsigned*)(0xBF809100))
#define ADC1BUFA ((unsigned*)(0xBF809110))
#define ADC1BUFB ((unsigned*)(0xBF809120))
#define ADC1BUFC ((unsigned*)(0xBF809130))
#define ADC1BUFD ((unsigned*)(0xBF809140))
#define ADC1BUFE ((unsigned*)(0xBF809150))
#define ADC1BUFF ((unsigned*)(0xBF809160))
#endif


// if USE_require, uncomment these definition.
/* #define CVRCON ((unsigned*)(0xBF809800)) */
/* #define CM1CON ((unsigned*)(0xBF80A000)) */
/* #define CM2CON ((unsigned*)(0xBF80A010)) */
/* #define CM3CON ((unsigned*)(0xBF80A020)) */
/* #define CMSTAT ((unsigned*)(0xBF80A060)) */
/* #define CTMUCON ((unsigned*)(0xBF80A200)) */

/* #define OSCCON ((unsigned*)(0xBF80F000)) */
/* #define OSCTUN ((unsigned*)(0xBF80F010)) */

/* #define REFOCON ((unsigned*)(0xBF80F020)) */
/* #define REFOTRIM ((unsigned*)(0xBF80F030)) */

/* #define CFGCON ((unsigned*)(0xBF80F200)) */
/* #define DDPCON ((unsigned*)(0xBF80F200)) */
/* #define DEVID ((unsigned*)(0xBF80F220)) */
/* #define SYSKEY ((unsigned*)(0xBF80F230)) */

/* #define PMD1 ((unsigned*)(0xBF80F240)) */
/* #define PMD2 ((unsigned*)(0xBF80F250)) */
/* #define PMD3 ((unsigned*)(0xBF80F260)) */
/* #define PMD4 ((unsigned*)(0xBF80F270)) */
/* #define PMD5 ((unsigned*)(0xBF80F280)) */
/* #define PMD6 ((unsigned*)(0xBF80F290)) */

/* #define NVMCON ((unsigned*)(0xBF80F400)) */
/* #define NVMKEY ((unsigned*)(0xBF80F410)) */
/* #define NVMADDR ((unsigned*)(0xBF80F420)) */
/* #define NVMDATA ((unsigned*)(0xBF80F430)) */
/* #define NVMSRCADDR ((unsigned*)(0xBF80F440)) */

/* #define RCON ((unsigned*)(0xBF80F600)) */
/* #define RSWRST ((unsigned*)(0xBF80F610)) */

#ifdef USE_REMAP
#define INT1R ((unsigned*)(0xBF80FA04))
#define INT2R ((unsigned*)(0xBF80FA08))
#define INT3R ((unsigned*)(0xBF80FA0C))
#define INT4R ((unsigned*)(0xBF80FA10))
#define T2CKR ((unsigned*)(0xBF80FA18))
#define T3CKR ((unsigned*)(0xBF80FA1C))
#define T4CKR ((unsigned*)(0xBF80FA20))
#define T5CKR ((unsigned*)(0xBF80FA24))
#define IC1R ((unsigned*)(0xBF80FA28))
#define IC2R ((unsigned*)(0xBF80FA2C))
#define IC3R ((unsigned*)(0xBF80FA30))
#define IC4R ((unsigned*)(0xBF80FA34))
#define IC5R ((unsigned*)(0xBF80FA38))
#define OCFAR ((unsigned*)(0xBF80FA48))
#define OCFBR ((unsigned*)(0xBF80FA4C))
#define U1RXR ((unsigned*)(0xBF80FA50))
#define U1CTSR ((unsigned*)(0xBF80FA54))
#define U2RXR ((unsigned*)(0xBF80FA58))
#define U2CTSR ((unsigned*)(0xBF80FA5C))
#define SDI1R ((unsigned*)(0xBF80FA84))
#define SS1R ((unsigned*)(0xBF80FA88))
#define SDI2R ((unsigned*)(0xBF80FA90))
#define SS2R ((unsigned*)(0xBF80FA94))
#define REFCLKIR ((unsigned*)(0xBF80FAB8))
#define RPA0R ((unsigned*)(0xBF80FB00))
#define RPA1R ((unsigned*)(0xBF80FB04))
#define RPA2R ((unsigned*)(0xBF80FB08))
#define RPA3R ((unsigned*)(0xBF80FB0C))
#define RPA4R ((unsigned*)(0xBF80FB10))
#define RPA8R ((unsigned*)(0xBF80FB20))
#define RPA9R ((unsigned*)(0xBF80FB24))
#define RPB0R ((unsigned*)(0xBF80FB2C))
#define RPB1R ((unsigned*)(0xBF80FB30))
#define RPB2R ((unsigned*)(0xBF80FB34))
#define RPB3R ((unsigned*)(0xBF80FB38))
#define RPB4R ((unsigned*)(0xBF80FB3C))
#define RPB5R ((unsigned*)(0xBF80FB40))
#define RPB7R ((unsigned*)(0xBF80FB48))
#define RPB8R ((unsigned*)(0xBF80FB4C))
#define RPB9R ((unsigned*)(0xBF80FB50))
#define RPB10R ((unsigned*)(0xBF80FB54))
#define RPB11R ((unsigned*)(0xBF80FB58))
#define RPB13R ((unsigned*)(0xBF80FB60))
#define RPB14R ((unsigned*)(0xBF80FB64))
#define RPB15R ((unsigned*)(0xBF80FB68))
#define RPC0R ((unsigned*)(0xBF80FB6C))
#define RPC1R ((unsigned*)(0xBF80FB70))
#define RPC2R ((unsigned*)(0xBF80FB74))
#define RPC3R ((unsigned*)(0xBF80FB78))
#define RPC4R ((unsigned*)(0xBF80FB7C))
#define RPC5R ((unsigned*)(0xBF80FB80))
#define RPC6R ((unsigned*)(0xBF80FB84))
#define RPC7R ((unsigned*)(0xBF80FB88))
#define RPC8R ((unsigned*)(0xBF80FB8C))
#define RPC9R ((unsigned*)(0xBF80FB90))
#endif

#ifdef USE_INT
#define INTCON ((unsigned*)(0xBF881000))
#define INTSTAT ((unsigned*)(0xBF881010))
#define IPTMR ((unsigned*)(0xBF881020))
#define IFS0 ((unsigned*)(0xBF881030))
#define IFS1 ((unsigned*)(0xBF881040))
#define IEC0 ((unsigned*)(0xBF881060))
#define IEC1 ((unsigned*)(0xBF881070))
#define IPC0 ((unsigned*)(0xBF881090))
#define IPC1 ((unsigned*)(0xBF8810A0))
#define IPC2 ((unsigned*)(0xBF8810B0))
#define IPC3 ((unsigned*)(0xBF8810C0))
#define IPC4 ((unsigned*)(0xBF8810D0))
#define IPC5 ((unsigned*)(0xBF8810E0))
#define IPC6 ((unsigned*)(0xBF8810F0))
#define IPC7 ((unsigned*)(0xBF881100))
#define IPC8 ((unsigned*)(0xBF881110))
#define IPC9 ((unsigned*)(0xBF881120))
#define IPC10 ((unsigned*)(0xBF881130))
#endif


/* #define BMXCON ((unsigned*)(0xBF882000)) */
/* #define BMXDKPBA ((unsigned*)(0xBF882010)) */
/* #define BMXDUDBA ((unsigned*)(0xBF882020)) */
/* #define BMXDUPBA ((unsigned*)(0xBF882030)) */
/* #define BMXDRMSZ ((unsigned*)(0xBF882040)) */
/* #define BMXPUPBA ((unsigned*)(0xBF882050)) */
/* #define BMXPFMSZ ((unsigned*)(0xBF882060)) */
/* #define BMXBOOTSZ ((unsigned*)(0xBF882070)) */

#ifdef USE_DMA
#define DMACON ((unsigned*)(0xBF883000))
#define DMASTAT ((unsigned*)(0xBF883010))
#define DMAADDR ((unsigned*)(0xBF883020))
#define DCRCCON ((unsigned*)(0xBF883030))
#define DCRCDATA ((unsigned*)(0xBF883040))
#define DCRCXOR ((unsigned*)(0xBF883050))
#define DCH0CON ((unsigned*)(0xBF883060))
#define DCH0ECON ((unsigned*)(0xBF883070))
#define DCH0INT ((unsigned*)(0xBF883080))
#define DCH0SSA ((unsigned*)(0xBF883090))
#define DCH0DSA ((unsigned*)(0xBF8830A0))
#define DCH0SSIZ ((unsigned*)(0xBF8830B0))
#define DCH0DSIZ ((unsigned*)(0xBF8830C0))
#define DCH0SPTR ((unsigned*)(0xBF8830D0))
#define DCH0DPTR ((unsigned*)(0xBF8830E0))
#define DCH0CSIZ ((unsigned*)(0xBF8830F0))
#define DCH0CPTR ((unsigned*)(0xBF883100))
#define DCH0DAT ((unsigned*)(0xBF883110))
#define DCH1CON ((unsigned*)(0xBF883120))
#define DCH1ECON ((unsigned*)(0xBF883130))
#define DCH1INT ((unsigned*)(0xBF883140))
#define DCH1SSA ((unsigned*)(0xBF883150))
#define DCH1DSA ((unsigned*)(0xBF883160))
#define DCH1SSIZ ((unsigned*)(0xBF883170))
#define DCH1DSIZ ((unsigned*)(0xBF883180))
#define DCH1SPTR ((unsigned*)(0xBF883190))
#define DCH1DPTR ((unsigned*)(0xBF8831A0))
#define DCH1CSIZ ((unsigned*)(0xBF8831B0))
#define DCH1CPTR ((unsigned*)(0xBF8831C0))
#define DCH1DAT ((unsigned*)(0xBF8831D0))
#define DCH2CON ((unsigned*)(0xBF8831E0))
#define DCH2ECON ((unsigned*)(0xBF8831F0))
#define DCH2INT ((unsigned*)(0xBF883200))
#define DCH2SSA ((unsigned*)(0xBF883210))
#define DCH2DSA ((unsigned*)(0xBF883220))
#define DCH2SSIZ ((unsigned*)(0xBF883230))
#define DCH2DSIZ ((unsigned*)(0xBF883240))
#define DCH2SPTR ((unsigned*)(0xBF883250))
#define DCH2DPTR ((unsigned*)(0xBF883260))
#define DCH2CSIZ ((unsigned*)(0xBF883270))
#define DCH2CPTR ((unsigned*)(0xBF883280))
#define DCH2DAT ((unsigned*)(0xBF883290))
#define DCH3CON ((unsigned*)(0xBF8832A0))
#define DCH3ECON ((unsigned*)(0xBF8832B0))
#define DCH3INT ((unsigned*)(0xBF8832C0))
#define DCH3SSA ((unsigned*)(0xBF8832D0))
#define DCH3DSA ((unsigned*)(0xBF8832E0))
#define DCH3SSIZ ((unsigned*)(0xBF8832F0))
#define DCH3DSIZ ((unsigned*)(0xBF883300))
#define DCH3SPTR ((unsigned*)(0xBF883310))
#define DCH3DPTR ((unsigned*)(0xBF883320))
#define DCH3CSIZ ((unsigned*)(0xBF883330))
#define DCH3CPTR ((unsigned*)(0xBF883340))
#define DCH3DAT ((unsigned*)(0xBF883350))
#endif

// USB cannot use because of bad clock source().
/* #define U1OTGIR ((unsigned*)(0xBF885040)) */
/* #define U1OTGIE ((unsigned*)(0xBF885050)) */
/* #define U1OTGSTAT ((unsigned*)(0xBF885060)) */
/* #define U1OTGCON ((unsigned*)(0xBF885070)) */
/* #define U1PWRC ((unsigned*)(0xBF885080)) */
/* #define U1IR ((unsigned*)(0xBF885200)) */
/* #define U1IE ((unsigned*)(0xBF885210)) */
/* #define U1EIR ((unsigned*)(0xBF885220)) */
/* #define U1EIE ((unsigned*)(0xBF885230)) */
/* #define U1STAT ((unsigned*)(0xBF885240)) */
/* #define U1CON ((unsigned*)(0xBF885250)) */
/* #define U1ADDR ((unsigned*)(0xBF885260)) */
/* #define U1BDTP1 ((unsigned*)(0xBF885270)) */
/* #define U1FRML ((unsigned*)(0xBF885280)) */
/* #define U1FRMH ((unsigned*)(0xBF885290)) */
/* #define U1TOK ((unsigned*)(0xBF8852A0)) */
/* #define U1SOF ((unsigned*)(0xBF8852B0)) */
/* #define U1BDTP2 ((unsigned*)(0xBF8852C0)) */
/* #define U1BDTP3 ((unsigned*)(0xBF8852D0)) */
/* #define U1CNFG1 ((unsigned*)(0xBF8852E0)) */
/* #define U1EP0 ((unsigned*)(0xBF885300)) */
/* #define U1EP1 ((unsigned*)(0xBF885310)) */
/* #define U1EP2 ((unsigned*)(0xBF885320)) */
/* #define U1EP3 ((unsigned*)(0xBF885330)) */
/* #define U1EP4 ((unsigned*)(0xBF885340)) */
/* #define U1EP5 ((unsigned*)(0xBF885350)) */
/* #define U1EP6 ((unsigned*)(0xBF885360)) */
/* #define U1EP7 ((unsigned*)(0xBF885370)) */
/* #define U1EP8 ((unsigned*)(0xBF885380)) */
/* #define U1EP9 ((unsigned*)(0xBF885390)) */
/* #define U1EP10 ((unsigned*)(0xBF8853A0)) */
/* #define U1EP11 ((unsigned*)(0xBF8853B0)) */
/* #define U1EP12 ((unsigned*)(0xBF8853C0)) */
/* #define U1EP13 ((unsigned*)(0xBF8853D0)) */
/* #define U1EP14 ((unsigned*)(0xBF8853E0)) */
/* #define U1EP15 ((unsigned*)(0xBF8853F0)) */

#ifdef USE_PORT
#define ANSELA ((unsigned*)(0xBF886000))
#define TRISA ((unsigned*)(0xBF886010))
#define PORTA ((unsigned*)(0xBF886020))
#define LATA ((unsigned*)(0xBF886030))
#define ODCA ((unsigned*)(0xBF886040))
#define CNPUA ((unsigned*)(0xBF886050))
#define CNPDA ((unsigned*)(0xBF886060))
#define CNCONA ((unsigned*)(0xBF886070))
#define CNENA ((unsigned*)(0xBF886080))
#define CNSTATA ((unsigned*)(0xBF886090))
#define ANSELB ((unsigned*)(0xBF886100))
#define TRISB ((unsigned*)(0xBF886110))
#define PORTB ((unsigned*)(0xBF886120))
#define LATB ((unsigned*)(0xBF886130))
#define ODCB ((unsigned*)(0xBF886140))
#define CNPUB ((unsigned*)(0xBF886150))
#define CNPDB ((unsigned*)(0xBF886160))
#define CNCONB ((unsigned*)(0xBF886170))
#define CNENB ((unsigned*)(0xBF886180))
#define CNSTATB ((unsigned*)(0xBF886190))
#endif
